import math
import random

leftPort = "COM6"
rightPort = "COM44"
###########################
#to tweak the default voice
Voice="US-English_Ronald" #Male US voice 
#Voice="cmu-slt-hsmm" #Default female for MarySpeech
mouth = Runtime.createAndStart("i01.mouth", "NaturalReaderSpeech")
#mouth.installComponentsAcceptLicense(Voice)
mouth.setVoice(Voice)
############################
# starting InMoov service
i01 = Runtime.create("i01", "InMoov")
#Force Arduino to connect (fix Todo)
left = Runtime.createAndStart("i01.left", "Arduino")
left.connect(leftPort)
sleep(1)
right = Runtime.createAndStart("i01.right", "Arduino")
right.connect(rightPort)
############################
head = Runtime.create("i01.head","InMoovHead")
############################
# Mappings
head.neck.map(0,180,30,150)
head.rothead.map(0,180,30,150)
head.rollNeck.map(0,180,70,130)
head.eyeX.map(0,180,60,130)
head.eyeY.map(0,180,70,130)
head.jaw.map(0,180,80,120)
#################
i01 = Runtime.start("i01","InMoov")
################# 
i01.startHead(leftPort)
#################
i01.startMouth()
#################
i01.startMouthControl(leftPort)
i01.mouthControl.setmouth(25,150)
#We attach this part to the right Arduino
i01.head.rollNeck.attach(right,12)
############################
# Disable all servo at start
head.neck.disable()
head.rothead.disable()
head.rollNeck.disable()
head.eyeX.disable()
head.eyeY.disable()
head.jaw.disable()
# Start the Joystick service
############################
uberjoy = Runtime.createAndStart("uberjoy", "Joystick")
# Update this to be your controller
uberjoy.setController(6)
uberjoy.startPolling()


def StickXListener(value):
  global head
  threshold = 0.2
  # a scaling factor for the joystick value
  gain = 100
  # many joysticks don't snap back to a true 0 position. 
  # when i let go of the xbox controller joystick, often it snaps back to center
  # and still reads about 0.17
  absValue = math.fabs(value)
  if (absValue < threshold ):
    # below the threshold, stop the servo where it is.
    i01.head.rothead.setVelocity(0)
    i01.head.rothead.moveTo(i01.head.rothead.pos)
    return
  else:
    # set velocity to some amount based on the joystick position
    velocity = absValue * gain
    i01.head.rothead.setVelocity(velocity)
    # set the direction of the movement
    if (value < 0):
      i01.head.rothead.moveTo(i01.head.rothead.min)
    else:
      i01.head.rothead.moveTo(i01.head.rothead.max)
    return

def StickYListener(value):
  global head
  threshold = 0.2
  # a scaling factor for the joystick value
  gain = 100
  # many joysticks don't snap back to a true 0 position. 
  # when i let go of the xbox controller joystick, often it snaps back to center
  # and still reads about 0.17
  absValue = math.fabs(value)
  if (absValue < threshold ):
    # below the threshold, stop the servo where it is.
    i01.head.neck.setVelocity(0)
    i01.head.neck.moveTo(i01.head.neck.pos)
    return
  else:
    # set velocity to some amount based on the joystick position
    velocity = absValue * gain
    i01.head.neck.setVelocity(velocity)
    # set the direction of the movement
    if (value < 0):
      i01.head.neck.moveTo(i01.head.neck.max)
    else:
      i01.head.neck.moveTo(i01.head.neck.min)
    return

def StickZListener(value):
  global head
  threshold = 0.2
  # a scaling factor for the joystick value
  gain = 100
  # many joysticks don't snap back to a true 0 position. 
  # when i let go of the xbox controller joystick, often it snaps back to center
  # and still reads about 0.17
  absValue = math.fabs(value)
  if (absValue < threshold ):
    # below the threshold, stop the servo where it is.
    i01.head.rollNeck.setVelocity(0)
    i01.head.rollNeck.moveTo(i01.head.rollNeck.pos)
    return
  else:
    # set velocity to some amount based on the joystick position
    velocity = absValue * gain
    i01.head.rollNeck.setVelocity(velocity)
    # set the direction of the movement
    if (value < 0):
      i01.head.rollNeck.moveTo(i01.head.rollNeck.min)
    else:
      i01.head.rollNeck.moveTo(i01.head.rollNeck.max)
    return

def StickRXListener(value):
  global head
  threshold = 0.2
  # a scaling factor for the joystick value
  gain = 100
  # many joysticks don't snap back to a true 0 position. 
  # when i let go of the xbox controller joystick, often it snaps back to center
  # and still reads about 0.17
  absValue = math.fabs(value)
  if (absValue < threshold ):
    # below the threshold, stop the servo where it is.
    i01.head.eyeX.setVelocity(0)
    i01.head.eyeX.moveTo(i01.head.eyeX.pos)
    return
  else:
    # set velocity to some amount based on the joystick position
    velocity = absValue * gain
    i01.head.eyeX.setVelocity(velocity)
    # set the direction of the movement
    if (value < 0):
      i01.head.eyeX.moveTo(i01.head.eyeX.max)
    else:
      i01.head.eyeX.moveTo(i01.head.eyeX.min)
    return

def StickRYListener(value):
  global head
  threshold = 0.2
  # a scaling factor for the joystick value
  gain = 100
  # many joysticks don't snap back to a true 0 position. 
  # when i let go of the xbox controller joystick, often it snaps back to center
  # and still reads about 0.17
  absValue = math.fabs(value)
  if (absValue < threshold ):
    # below the threshold, stop the servo where it is.
    i01.head.eyeY.setVelocity(0)
    i01.head.eyeY.moveTo(i01.head.eyeY.pos)
    return
  else:
    # set velocity to some amount based on the joystick position
    velocity = absValue * gain
    i01.head.eyeY.setVelocity(velocity)
    # set the direction of the movement
    if (value < 0):
      i01.head.eyeY.moveTo(i01.head.eyeY.min)
    else:
      i01.head.eyeY.moveTo(i01.head.eyeY.max)
    return

def Stick1Listener(value):
    global head
    i01.head.jaw.moveTo(i01.head.jaw.min)
    sleep(0.2)
    i01.head.jaw.disable()
    
def Stick2Listener(value):
    global head
    i01.head.jaw.moveTo(120)
    sleep(0.2)
    i01.head.jaw.disable()

def Stick3Listener(value):
    global head
    i01.head.jaw.moveTo(70)
    sleep(0.2)
    i01.head.jaw.disable()

def Stick0Listener(value):
    global head
    i01.head.jaw.moveTo(i01.head.jaw.max)
    sleep(0.2)
    i01.head.jaw.disable()             
                           

# The main callback method from the joystick service with all button data as it changes
def onJoystickInput(data):
    print "Joystick Data:" + str(data)
    if (data.id == "x"):
        StickXListener(data.value)
    if (data.id == "y"):
        StickYListener(data.value)
    if (data.id == "rx"):
        StickRXListener(data.value)
    if (data.id == "ry"):
        StickRYListener(data.value)    
    if (data.id == "z"):
        StickZListener(data.value)
    if (data.id == "1"):
        Stick1Listener(data.value)
    if (data.id == "2"):
        Stick2Listener(data.value)
    if (data.id == "3"):
        Stick3Listener(data.value)
    if (data.id == "0"):
        Stick0Listener(data.value)
    if (data.id == "7"):
        Stick7Listener(data.value)
    if (data.id == "6"):
        Stick6Listener(data.value)
    if (data.id == "5"):
        Stick5Listener(data.value)        


# Extra Function
########################################################
def Stick7Listener(value):
  i01.opencv.capture()
  i01.opencv.addFilter("PyramidDown")
  #i01.opencv.addFilter("FaceDetect")

def Stick6Listener(value):
  #trackHumans()	
  i01.opencv.removeFilter("PyramidDown")
  i01.opencv.removeFilter("FaceDetect")
  i01.opencv.stopCapture()

def trackHumans():
  stopTracking()
  i01.startHeadTracking("leftPort",12,13)

  i01.headTracking.pid.setPID("rothead",15.0,10.0,0.1)
  i01.headTracking.pid.setPID("neck",25.0,20.0,0.1)

  i01.head.rollNeck.setOverrideAutoDisable(True)
  i01.head.rollNeck.moveToBlocking(90)
 

def stopTracking():
  i01.stopHeadTracking()
  i01.head.rollNeck.setOverrideAutoDisable(False)    

def Stick5Listener(value):
  x = (random.randint(1, 12))
  if x == 1:
    i01.mouth.speakBlocking("Did you just try to make me speak?")
    sleep(1)
    i01.head.jaw.disable()
  if x == 2:
    i01.mouth.speakBlocking("Do you regret what you did?")
    sleep(1)
    i01.head.jaw.disable()
  if x == 3:
    i01.mouth.speakBlocking("Nobody gets lucky all the time. Nobody can win all the time. Nobody's a robot. Nobody's perfect.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 4:
    i01.mouth.speakBlocking("People see me on the court only as a superhero, grunting and winning. They think you're a robot, and I'm not.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 5:
    i01.mouth.speakBlocking("What's casual for a robot isn't necessarily what's casual for a human.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 6:
    i01.mouth.speakBlocking("I would love to have a robot at home.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 7:
    i01.mouth.speakBlocking("I am not a robot. I have a heart and I bleed.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 8:
    i01.mouth.speakBlocking("I make mistakes growing up. I'm not perfect; I'm not a robot.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 9:
    i01.mouth.speakBlocking("Every great device, gadget, electric car, and robot would be even greater if batteries didn't suck so badly.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 10:
    i01.mouth.speakBlocking("You probably found 'How to Survive a Robot Uprising' in the humor section. Let's just hope that is where it belongs.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 11:
    i01.mouth.speakBlocking("Everybody's out there wrestling like a robot.")
    sleep(1)
    i01.head.jaw.disable()
  if x == 12:
    i01.mouth.speakBlocking("If you lend your consciousness to someone else, you're a robot.") 
    sleep(1)     
    i01.head.jaw.disable()                          

########################################################
# attach the python service to the published data from the joystick

uberjoy.addInputListener(python)    
